   Option Explicit
   '==========================================================================='
   '  "VertaalRoots3a.vbs"    Date Created: 29-Dec-2002    Date Updated: 29-Dec-2002
   '
   '  Dit VBS (Visual Basic Script) programma doet het volgende:
   '  1)  Leest een bestand, vertaalt het, en maakt een nieuw bestand aan.
   '  2)  De termen die vertaalt worden staan in het bestand : vertaal.txt (cTransF)
   '  3)  Het nieuwe bestand komt in een 'translate folder' (cOut)
   '
   '  Om de procedure uit te voeren dubbel-klik op het bestand of vanuit  
   '  START --> Uitvoeren : cscript vertaalrootsv4.vbs
   '
   ' De tekst tussen de quote's (") bij cOUT en cTransF kan men wijzigen.
   '
   '  Wijzigingen:
   '  -------------------------------------------------------------------------
   '  29-Dec-2002.0  Aangemaakt.
   '  01-Jan-2003.0  Gewijzigd.
   '  02-Jan-2003.0  Gewijzigd in vertaalrootsv1.vbs
   '==========================================================================='
        
   ' Uitvoer folder
    Const cOUT = "c:\vertaalroots\vertaal\"

   ' Bestand met te vertalen teksten
    Const cTransF = "c:\vertaalroots\vertaal.txt"

    Const cVBS = "VertaalRootsV1.vbs"
    Const cMsgTitle = "Vertaal Stamboom"
    Const cMadeby1 = "Gemaakt door : Fred Baltus"
    Const cMadeby2 = "Mag vrijelijk gebruikt worden."
    Const cMadeby3 = "fredbaltus@hotmail.com"
    Const cMadeby4 = "copyright 2003 - Fred Baltus"
    Const cMadeby5 = "Thanks to : McKirahan"


    Dim objWSH
    Set objWSH = CreateObject("WScript.Shell") 

    Dim strMadeby 
        strMadeby = Chr(13) & Chr(10) & _
                    cMadeby1 & Chr(13) & Chr(10) & _
                    cMadeby2 & Chr(13) & Chr(10) & _
                    Chr(10) & _
                    cMadeby3 & Chr(13) & Chr(10) & _
                    cMadeby4 & _
                    Chr(13) & Chr(10) & _
			  Chr(10) & _
                    cMadeby5

   '*
   '*  Start Melding
   '*

    MsgBox "'" & cVBS & "' is gestart." & _
     Chr(13) & Chr(10) & strMadeBy ,0,cMsgTitle


   '*
   '*  Declare Globals
   '*
    Dim intGFI
        intGFI = 0
    Dim strOT1
    Dim strOT1F

    Dim strOT2
    Dim intOTF
        intOTF = 0
   '*
   '*  Verwerking
   '*
    Dim objFSO
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    Call Folder()
    Set objFSO = Nothing
   '*
   '*  Stop melding
   '*
    MsgBox "'" & cVBS & "' is gestopt.",0,cMsgTitle
  
Sub Folder()
   '*
   '*  Bestaat uitvoer folder?
   '*
    If Not objFSO.FolderExists(cOUT) Then
        MsgBox "Uitvoer folder bestaat niet!",0,cMsgTitle
        Exit Sub
    End If
   '*
   '* Bestaat vertaal bestand?
   '*
    If Not objFSO.FileExists(cTransF) Then
        MsgBox "Vertaal bestand bestaat niet!",0,cMsgTitle
        Exit Sub
    End If


   '*
   '*  Selecteer bron folder
   '*
    Dim strFOL
        strFOL = BrowseForFolder("Folder","Selecteer bron folder","")
   '*
   '*  Bestaat bron folder?
   '*
    If Not objFSO.FolderExists(strFOL) Then
        MsgBox "Bron folder bestaat niet!",0,cMsgTitle
        Exit Sub
    End If
   '*
   '*  Bestaan bron bestanden?
   '*
    Dim objGFO
    Set objGFO = objFSO.GetFolder(strFOL)
    If objGFO.Files.Count = 0 Then
        MsgBox "Bron folder heeft geen bestanden!",0,cMsgTitle
        Exit Sub
    End If
   '*
   '*  Verwerk bron bestanden
   '*
    Dim objGFI
    Set objGFI = objGFO.Files
    Dim strGFI
    For Each strGFI in objGFI
        If LCase(Right(strGFI,4)) = ".htm" or LCase(Right(strGFI,5)) = ".html" Then
            intGFI = intGFI + 1
            strOT1 = strGFI 
            strOT2 = cOUT & Mid(strOT1,InStrRev(strOT1,"\")+1)
            objWSH.Popup "Het bestand " & strOT1 & " wordt vertaald.",1,cMsgTitle,64
            Call ReadWrite()
        End If
    Next
    Set objGFI = Nothing
    Set objGFO = Nothing
   '*
    If intGFI = 0 Then
        MsgBox "Bron folder heeft geen '.htm' bestanden!",0,CMsgTitle
        Exit Sub
    End If
   '*
   '*  Toon aantallen
   '*
    MsgBox FormatNumber(intGFI,0) & " bestanden hadden" & vbCrLf & FormatNumber(intOTF,0) & " wijzigingen.",0,cMsgTitle
End Sub

Sub ReadWrite()
   '*
   '*  Declareer Variabelen
   '*
    Dim intE2D
    Dim strE2D
    Dim intOFF
    Dim strOTF
    Dim strTRF
   '*
   '*  Open Bestanden
   '*

    Dim objFSO
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    If Not objFSO.FileExists(strOT1) Then
        MsgBox "Bestand bestaat niet!",0,cMsgTitle
        Exit Sub
    End If
 
    Dim objOT1
    Set objOT1 = objFSO.OpenTextFile(strOT1,1)
    Dim objOT2
    Set objOT2 = objFSO.OpenTextFile(strOT2,2,true)
    Dim objOT3
    Set objOT3 = objFSO.OpenTextFile(cTransF,1)

   '*
   '*  Lees en schrijf bestanden
   '*
   
   Do While Not objOT1.AtEndOfStream
         strOTF = objOT1.ReadLine()
         Do While Not objOT3.AtEndOfStream  
            strTRF = objOT3.ReadLine()
            strE2D = Split(strTRF,"|")
            
            intOFF = InStr(strOTF,strE2D(0))
            do while intOFF > 0 
'            If intOFF > 0 Then
              strOTF = Left(strOTF,intOFF-1) & strE2D(1) & Mid(strOTF,intOFF+Len(strE2D(0)))

              intOTF = intOTF + 1
              intOFF = InStr(strOTF,strE2D(0))
       
'            End If
            loop
        Loop
        objOT3.Close()
        Set objOT3 = objFSO.OpenTextFile(cTransF,1)
        objOT2.WriteLine(strOTF)
    Loop
   '*
   '*  Sluit bestanden
   '*
        objOT1.Close()
    Set objOT1 = Nothing
        objOT2.Close()
    Set objOT2 = Nothing
    Set objOT3 = Nothing

End Sub

 
Function BrowseForFolder(sBFF,sPMT,sDIR)
    BrowseForFolder = ""
    If sBFF <> "Folder" And sBFF <> "File" Then Exit Function
   '*
    Dim objSHL
    Set objSHL = CreateObject("Shell.Application")
    Dim objB4F
   '*
    On Error Resume Next
    If sBFF = "Folder" Then
        Set objB4F = objSHL.BrowseForFolder(&H0,sPMT,&H0031,sDIR)
    Else
        Set objB4F = objSHL.BrowseForFolder(&H0,sPMT,&H4031,sDIR)
    End If
    BrowseForFolder = objB4F.ParentFolder.ParseName(objB4F.Title).Path
    If Err.Number <> 0 Then BrowseForFolder = ""
   '*
    Set objB4F = Nothing
    Set objSHL = Nothing
End Function

   
